//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : cursor.cpp
//
// Classes     : Cursors
//
// Description : a class to hold cursor data for each input window,  
//               positions both in the window and in the data.             
//
// Copyright   : (c) 1991, 1993 Ian Craggs               
//
//////////////////////////////////////////////////////////////////////////////

#include <conio.h>

#include "Cursor.h"
#include "Mwindow.h"


void Cursors::Show()
{
  if (fDisplayRowCol)
    theMsgWind.setRowCol(theCurRow, theCurCol);
  gotoxy(theCol, theRow);
} // end Cursors::Show


void Cursors::Move(direction aDir)
{
  switch (aDir)
  {
    case UP :
      if (theCurLine->PrevOf() != NULL)
      {
	--theRow;
	--theCurRow;
	theCurLine = theCurLine->PrevOf();
      } // endif
      break;

    case DOWN :
      if (theCurLine->NextOf() != NULL)
      {
	++theRow;
	++theCurRow;
	theCurLine = theCurLine->NextOf();
      } // endif
      break;

    case LEFT :
      if (theCurCol > 0)
      {
	--theCol;
	--theCurCol;
      } // endif
      break;

    case RIGHT :
      ++theCol;
      ++theCurCol;
      break;

  } // endswitch

  Show();

}// end Cursors::Move


void Cursors::Reset(Lines *aLine)
{
  theRow = theCol = 1;
  theCurRow = theCurCol = 0;
  theCurLine = aLine;
  theMsgWind.setRowCol(theCurRow, theCurCol);
} // end Reset


void Cursors::Home()
{
  theCol = 1;
  theCurCol = 0;
  theMsgWind.setRowCol(theCurRow, theCurCol);
} // end Home




