//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : cwindow.h
//
// Classes     : CommandWindows
//
// Description : derived from InputWindows, runs commands.                     
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(CWINDOW_H)
#define CWINDOW_H

#include "Globals.h"
#include "IWindow.h"

class CommandWindows : public InputWindows
{
public :

  void Enter();                        // Run a command.

  CommandWindows();                    // Constructor.

  ~CommandWindows();                   // Destructor.

// For base class InputWindows

  RETCODE Refresh();                   // Refresh the display of the window.

private:

  int theNoOfCommands;                 // No. of remembered commands.

}; // end class CommandWindows

#endif
