//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : editor.h
//
// Classes     : Editors
//
// Description : the main class of the editor, Run() is the main loop.     
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(EDITOR_H)
#define EDITOR_H

#include "Globals.h"


#include "FWindow.h"
#include "CWindow.h"
#include "Mark.h"

class Editors
{
public:

  Editors()                            // Constructor.
    { isOnCmdLine = FALSE; }

  void Run(char *);                    // Run the editor.

  ~Editors()
    { delete theCurFile; }             // Delete remaining file windows.

private:

  Marks theMark; 		       // Lines marked.

  Windows theHelpWind;                 // Function key help line.

  FileWindows *theFirstFile,           // First file in file list.
	      *theCurFile;             // Current file being edited.

  CommandWindows theCmdLine;           // Command line.

  InputWindows *theCurWindow;          // Currently active window; can be
				       // file or command.
  bool isOnCmdLine;

}; // end class Editors

#endif
