//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : globals.h
//
// Classes     : none
//
// Description : global typedefs for use in all classes.                   
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(GLOBALS_H)
#define GLOBALS_H


// Boolean type

typedef enum
{
  FALSE,
  TRUE
} bool;


// Direction type

typedef enum
{
  UP,
  DOWN,
  LEFT,
  RIGHT
} direction;


// Return codes

typedef enum retcode
{
  OK,
  NO_MORE_MEMORY,
  FILE_NOT_OPENED,
  CANT_MOVE,
  CANT_EDIT,
  CANT_FIND
} RETCODE;


// Editor operation codes.

typedef enum opcode
{
  NOP,
  BACKSP,
  CHAR,                                // A normal ASCII character.
  ASCII = CHAR,
  DELETE,
  PGDN,
  PAGE_DOWN = PGDN,
  PGUP,
  PAGE_UP = PGUP,
  CUR_UP,
  CUR_LEFT,
  CUR_RIGHT,
  CUR_DOWN,
  QUIT,
  UNDO,
  SAVE,
  ENTER,
  INSERT,
  COMMAND,
  HOME,
  DELETE_LINE,
  MARK_LINE,
  MARK_BLOCK,
  MOVE_MARK,
  COPY_MARK,
  DELETE_MARK,
  UNMARK,
  SHIFT_MARK_RIGHT,
  SHIFT_MARK_LEFT,
  SPLIT,
  JOIN,
  EDIT,
  NEXT_FILE,
  PREV_FILE,
  TERMINATE,
  SAVEQUIT,
  DOS,
  COMMAND_TYPE,                        // Type on command line - internal.
  COMMAND_EDIT,                        // Type "EDIT " on command line.
  COMMAND_NAME,                        // Type "NAME " on command line.
  NAME,                                // Rename file.
  ERASE_EOL,                           // Erase to end of line.
  END,
  FIND,
  FIND_AGAIN,
  CHANGE,
  TAB,
  BACK_TAB,
  TOP_OF_FILE,
  BOTTOM_OF_FILE,
  GOTO,
  HELP,
  MAX_OPS
} OPCODE;


typedef enum
{
  NONE,
  MARKED_LINES_ONLY,
  ALL_OCCURRENCES
} CHANGE_OPTS;

#endif
