//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : keyboard.h
//
// Classes     : Keyboards
//
// Description : interface to keyboard, including keystroke to editor
//               function mapping.     
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(KEYBOARD_H)
#define KEYBOARD_H

#include "Globals.h"

#include "Util.h"
#include "Line.h"
#include "Mwindow.h"

#include <conio.h>

class Keyboards
{
public:

  OPCODE getOp();

  int getChar()
    { return ascii_char; }

  Keyboards()
   { isInserting = FALSE; theQueuedOp = NOP; setCursor(); }

  void ToggleInsert()
    { isInserting = (isInserting) ? FALSE : TRUE;
      theMsgWind.setMode(isInserting); setCursor(); }

  bool isInInsertMode()
    { return isInserting; }

  void setCursor()
    { setCursorType((isInserting) ? _SOLIDCURSOR : _NORMALCURSOR); }

  void InsertOp(OPCODE anOp)
    { theQueuedOp = anOp; }

  void InsertParm(char *aString)
    { theQueuedParm.SetData(aString); }

  char *ParmOf()
    { return theQueuedParm.DataOf(); }

private:

  OPCODE theQueuedOp;
  Lines  theQueuedParm;

  bool isInserting;

  int ascii_char;
};

#if !defined(KEYBOARD_OWNER)
  extern
#endif
  Keyboards theKeyboard;

#endif
