//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : line.h
//
// Classes     : Lines
//
// Description : this class holds a line of data for InputWindows.         
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(LINE)
#define LINE

#include <stdio.h>

#include "Globals.h"

class Lines
{
public:

  Lines(char* = NULL);

  RETCODE SetData(char *);

  char *DataOf(int = 1);

  void SetNext(class Lines *aLine)
    {theNext = aLine; }

  class Lines *NextOf()
    { return theNext; }

  void SetPrev(class Lines *aLine)
    { thePrev = aLine; }

  class Lines *PrevOf()
    { return thePrev; }

  void EraseEOL(int);

  void ReplaceChar(char, int);

  void InsertChar(char, int);

  void DeleteChar(int);

  void Strip();

  void Replace(Lines *);

  void ReplaceString(int, int, char*);

  bool isReadOnly;

  bool isMarked;

private:

  int         theLength;
  char        *theData;
  class Lines *thePrev,
	      *theNext;

  RETCODE Lengthen(int);

}; // end class Lines

#endif
