//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : mwindow.h
//
// Classes     : MessageWindows
//
// Description : derived from Windows, displays messages and status info.      
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#include "Mwindow.h"
#include "Keyboard.h"

#include <string.h>
#include <mem.h>


MessageWindows::MessageWindows()
{
  theStdMsg = new char[/*theNoOfCols*/80 + 1];
  theStdMsg[theNoOfCols] = '\0';
  isMsgActive = FALSE;
} // end MessageWindows constructor


MessageWindows::~MessageWindows()
{
  delete[] theStdMsg;
} // end MessageWindows destructor


void MessageWindows::resetMsg()
{
  if (isMsgActive)
  {
    isMsgActive = FALSE;
    DisplayLine(theStdMsg);
  } // end if
} // end resetMsg


void MessageWindows::setFileName(char* aString)
{
  memset(theStdMsg, ' ', 66);
  *stpcpy(theStdMsg, aString) = ' ';
  if (!isMsgActive)
    DisplayLine(theStdMsg);
} // end


void MessageWindows::setRowCol(int aRow, int aCol)
{
  char NumBuf[17];
  memset(&theStdMsg[66], ' ', 11);
  sprintf(NumBuf, "%d", aRow);
  *stpcpy(&theStdMsg[67], NumBuf) = ' ';
  sprintf(NumBuf, "%d", aCol + 1);
  *stpcpy(&theStdMsg[73], NumBuf) = ' ';
  if (!isMsgActive)
    DisplayLine(theStdMsg);
} // end


void MessageWindows::setMode(bool isInsertMode)
{
  stpcpy(&theStdMsg[77], isInsertMode ? "Ins" : "Rep");
  if (!isMsgActive)
    DisplayLine(theStdMsg);
} // end setMode


void MessageWindows::DisplayLine(char *aLine)
{
  Windows *theCurrent = Windows::Active();
  int x = wherex();
  int y = wherey();
  Windows::DisplayLine(aLine);
  theCurrent->Activate();
  gotoxy(x, y);
} // end DisplayLine
