//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : mwindow.h
//
// Classes     : MessageWindows
//
// Description : derived from Windows, displays messages and status info.      
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(MWINDOW_H)
#define MWINDOW_H

#include "Globals.h"
#include "Window.h"

class MessageWindows : public Windows
{
public :

  MessageWindows();                    // Constructor.

  ~MessageWindows();                   // Destructor.

  void setMsg(char* aMsg)
    { DisplayLine(aMsg); isMsgActive = TRUE; }

  void resetMsg();

  void setFileName(char*);

  void setRowCol(int, int);

  void setMode(bool);

  bool isMessageActive()
    { return isMsgActive; }

  void DisplayLine(char *);

private :

  char *theStdMsg;

  bool isMsgActive;

}; // end class MessageWindows


#if !defined(MSG_WIND_OWNER)
  extern
#endif
  MessageWindows theMsgWind;

#endif
