//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : screen.h
//
// Classes     : Screens
//
// Description : setup, information about and restoration of, the screen.  
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#include <conio.h>

#include "Screen.h"


Screens::Screens()
{
  directvideo = 1;
  _wscroll = 0;                        // No automatic scrolling in lib fns.
  struct text_info ti;
  gettextinfo(&ti);
  theNoOfRows = ti.screenheight;
  theNoOfCols = ti.screenwidth;
  theStartAttr = ti.attribute;
  clrscr();
} // end Screens constructor


void Screens::Clear()
{
  window(1, 1, theNoOfCols, theNoOfRows);
  textattr(theStartAttr);
  clrscr();
} // end Clear


