//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : screen.h
//
// Classes     : Screens
//
// Description : setup, information about and restoration of, the screen.  
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(SCREEN_H)
#define SCREEN_H

#include "Globals.h"

class Screens
{
public:

  Screens();                           // Constructor

  ~Screens()                           // Destructor
    { Clear(); }

  void Clear();

  int RowsOf()
    { return theNoOfRows; }

  int ColsOf()
    { return theNoOfCols; }

private:

  unsigned char theStartAttr;          // Screen attribute before start-up.

  int theNoOfRows,                     // No. of rows on screen.
      theNoOfCols;                     // No. of cols. on screen.

}; // end class Screens


#if !defined(SCREEN_OWNER)
  extern
#endif
  Screens theScreen;


#endif
