//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : util.cpp
//
// Classes     : none - class utilities
//
// Description : class utilities: a replcement for _setcursortype() and
//               a fast screen output function also mixed up from the
//               Borland run-time library.
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////


#include <conio.h>
#include <_video.h>

#include "util.h"


// The next function replaces the library function _setcursortype which
// has a bug in the setting of the normal cursor for 43-line mode.

/*
 *      C/C++ Run Time Library - Version 5.0
 *
 *      Copyright (c) 1987, 1992 by Borland International
 *      All Rights Reserved.
 *
 */

void setCursorType( int cur_t )
  {
  struct text_info t;
  int start, end;

  gettextinfo( &t );

  switch( cur_t )
    {
    case _NOCURSOR:
      start = 0x20, end = 0;
      break;
    case _SOLIDCURSOR:
      if( t.screenheight == 43 )
	start = 0, end = 8;
      else
	start = 0, end = t.currmode == MONO ? 12 : 7;
      break;
    case _NORMALCURSOR:
      if( t.currmode == MONO )
	start = 11, end = 12;
      else
	start = 6,  end = t.screenheight == 43 ? 8 : 7;
    }

  _CH = start;
  _CL = end;
  _AH = 1;
  _VideoInt();
}


void PutString(const char *s, int len)
{
  int col = _wherex();
  int row = _wherey();
  static unsigned int buf[132];
  unsigned int *pBuf = buf;
  int count = len;

  while (count--) {
    _AH = _video.attribute;
    _AL = *s++;
    *pBuf++ = _AX;
  } // end while

  __vram(__vptr(col + 1, row + 1), buf, len);

  _DL = col + len;
  _DH = row;
  _AH = V_SET_CURSOR_POS;
  _BH = 0;
  _VideoInt();

} /* PutString */





