//////////////////////////////////////////////////////////////////////////////
//
// Project     : a DOS full-screen editor using the object-oriented
//               facilities of C++.
//
// File name   : window.h
//
// Classes     : Windows
//
// Description : the base class for all screen windows, including file,
//               command and message windows.     
//
// Copyright   : (c) 1991, 1993 Ian Craggs
//
//////////////////////////////////////////////////////////////////////////////
          
#if !defined(WINDOW_H)
#define WINDOW_H

#include <stdio.h>
#include <conio.h>

#include "Globals.h"
#include "Cursor.h"

class Windows
{

public:

  bool isActive()
    { return (ActiveWindow == this) ? TRUE : FALSE; }

  void Activate();

  void Setup(int, int, int, int, int, int);

  void DisplayLine(Lines *, int = 1,
			    int = 1);  // Write text to the window.

  void DisplayLine(char *, int = 1);   // Write text to the window.

  void Cls()
    { Activate(); clrscr(); }

  bool isFarRight(Cursors &aCursor)
    { return (aCursor.ColOf() >= theNoOfCols) ? TRUE : FALSE; }

  bool isFarLeft(Cursors &aCursor)
    { return (aCursor.ColOf() <= 1) ? TRUE : FALSE; }

  bool isFarUp(Cursors &aCursor)
    { return (aCursor.RowOf() <= 1) ? TRUE : FALSE; }

  bool isFarDown(Cursors &aCursor)
    { return (aCursor.RowOf() >= theNoOfRows) ? TRUE : FALSE; }

  void Scroll(direction, int);

  void Reverse();

  Windows* Active()
    { return ActiveWindow; }

protected:

  int theNoOfRows,                     // No. of rows in window.
      theNoOfCols;                     // No. of cols in window.

private:

  static Windows* ActiveWindow;        // Which window is active?

  int theLeft,  theTop,
      theRight, theBottom;             // Window coordinates.
  int theColor,                        // The display atribute.
      theBackColor;                    // The background.

}; // end class Windows


#endif
